﻿#region Copyright
// /************************************************************************
//    Copyright (c) 2016 Jamie Rees
//    File: RequestViewModel.cs
//    Created By: Jamie Rees
//   
//    Permission is hereby granted, free of charge, to any person obtaining
//    a copy of this software and associated documentation files (the
//    "Software"), to deal in the Software without restriction, including
//    without limitation the rights to use, copy, modify, merge, publish,
//    distribute, sublicense, and/or sell copies of the Software, and to
//    permit persons to whom the Software is furnished to do so, subject to
//    the following conditions:
//   
//    The above copyright notice and this permission notice shall be
//    included in all copies or substantial portions of the Software.
//   
//    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
//    LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
//    OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
//    WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  ************************************************************************/
#endregion

using System;
using Ombi.Store;

namespace Ombi.UI.Models
{
    public class RequestViewModel
    {
        public int Id { get; set; }
        public int ProviderId { get; set; }
        public string ImdbId { get; set; }
        public string Overview { get; set; }
        public string Title { get; set; }
        public string PosterPath { get; set; }
        public DateTime ReleaseDate { get; set; }
        public bool Released { get; set; }
		public long ReleaseDateTicks { get; set; }
        public RequestType Type { get; set; }
        public string Status { get; set; }
        public bool Approved { get; set; }
        public string[] RequestedUsers { get; set; }
        public DateTime RequestedDate { get; set; }
        public long RequestedDateTicks { get; set; }
        public string ReleaseYear { get; set; }
        public bool Available { get; set; }
        public bool Admin { get; set; }
        public int IssueId { get; set; }
        public string TvSeriesRequestType { get; set; }
        public string MusicBrainzId { get; set; }
        public QualityModel[] Qualities { get; set; }
        public string ArtistName { get; set; }
        public Store.EpisodesModel[] Episodes { get; set; }
        public bool Denied { get; set; }
        public string DeniedReason { get; set; }
        public RootFolderModel[] RootFolders { get; set; }
        public bool HasRootFolders { get; set; }
        public string CurrentRootPath { get; set; }
    }
}
